/*
 *	Copyright (C) 1996 William Adams.
 *	All rights reserved.
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 1, or (at your option)
 *	any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * MANIFEST: interface definition for audio.c
 */
 
#ifndef AUDIO_H
#define AUDIO_H

#include <SoundFile.h>

class BAudioSubscriber;

class AAudioOutputDevice
{
public:
			AAudioOutputDevice();
			
		void Play (char * data, long datalen);
		void Play (BSoundFile *aFile);
		bool PlayNextPart(char *buffer, long count);
		
		long	SetParameters(long bytesPerSample,
								long samplesPerFrame,
								long byteOrder,
								long sampleFormat);
		long	SetVolume(const float l_volume, const float r_volume);
		long	SetSamplingRate(long sRate);
		

	long	fDataLength;
	char *	fData;
	long	fOffset;
	long	fAmountLeft;
	BSoundFile	*fSoundFile;
	
protected:
	BAudioSubscriber	*fSubscriber;
	long	fSubscriberID;	

private:

};


class AmuLawAudioDevice
{
public:
			AmuLawAudioDevice();
			
		void Play (int argc, char **argv);
		bool  PlayNextPart(char *buffer, long count);
		void SetVolume (const double);
		void Read (char *filename, char **data, long *datalen);
		void Write (char *filename, char *data, long datalen);


	int		fArgc;
	char **	fArgv;
	int	fCurrentSound;
	record_ref	fSoundRef;
	BSoundFile	fSoundFile;
	int		fMoreToPlay;
	
protected:
	BAudioSubscriber	*fSubscriber;
	long	fSubscriberID;	

private:

};


int ulaw2linear(unsigned char ulawbyte);


#endif /* AUDIO_H */
