/*
** COPYRIGHT
**
** This code is so simple, it's not even worth a copyright
** notice.  It's public domain, do what you want with it.
**
** Author: William Adams
*/

#include <stdio.h>
#include <Application.h>
#include "audio.h"

AmuLawAudioDevice audioDevice;

class SoundApplication : public BApplication
{
public:
					SoundApplication();
		
	virtual	void	ArgvReceived(int argc, char **argv);
	virtual	void	ReadyToRun();
	
protected:
	record_ref	fSoundRef;
	char fFileName[1024];
	
	long fsampleFormat;
	long fchannelCount;
	long fsamplingRate;
	long fbyteOrder;
	long fbytesPerSample;

private:

};


//===========================================================
// Class: SoundApplication
//
// This is the interface to the sound application
//===========================================================

SoundApplication::SoundApplication()
	: BApplication('ASND')
{
	fsampleFormat = B_MULAW_SAMPLES;
	fchannelCount = 1;
	fsamplingRate = 8000;
	fbyteOrder = B_BIG_ENDIAN;
	fbytesPerSample = 2;
}

void
SoundApplication::ArgvReceived(int argc, char **argv)
{	
	if (argc < 2)
		puts("Usage: playsound <soundfile>");
		
	printf("ArgvReceived\n");
	
	audioDevice.Play(argc, argv);

}

void
SoundApplication::ReadyToRun()
{
	printf("ReadyToRun\n");
	
	//PostMessage(B_QUIT_REQUESTED);
}

int
main()
{
	SoundApplication *my_app = new SoundApplication();
	
	my_app->Run();
	delete my_app;

	return 0;
}
